<?php

namespace HCM\FPA\Entity;

use \HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\TkDI;
use HCM\FPA\Entity\FpatipoferiashEntity;

class FpatipoferiasmEntity extends TkEntity
{   
    
    public function __construct($entityManager, $hcmParameters){
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $this->hcmParameters->getDtCompetencia();

        parent::__construct(null,$entityManager);
    }

    private function _inicializaLista($nrOrgPadrao, $nrOrgTrabalho){
        $tmp = $this->entityManager->getRepository(Repositories::FPA_TIPOFERIASM)->retornaTipoFerias($this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);
        foreach ($tmp as $tmp_tipo_ferias) {
            $this->addItem($tmp_tipo_ferias, $tmp_tipo_ferias->getNrtipoferias());
        }
    }

    public function retornaTipoFerias($nrOrgPadrao, $nrOrgTrabalho, $nr_tipoferias){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista($nrOrgPadrao, $nrOrgTrabalho);
            $itens = $this->getItems();
        }

        return $itens[$nr_tipoferias];
    }

    public function retornaQtdMesesPeriodoAquisitivo($item){

        $id_periodo_aquisitivo = $item->historico->getIdperaquisitivo();

        switch ($id_periodo_aquisitivo){
        case FpatipoferiashEntity::IDPERAQUISITIVO_ANO:
            return $item->historico->getQtperaquisitivo() * 12;
        case FpatipoferiashEntity::IDPERAQUISITIVO_MES:
            return $item->historico->getQtperaquisitivo();
        case FpatipoferiashEntity::IDPERAQUISITIVO_DIA:
            return $item->historico->getQtperaquisitivo() / 30;
        default:
            MsgCalculo::getInstance()->adicionaMensagem('Período aquisitivo não definido.');
            return;
        }
    }

    public function novoMestre($nrtipoferias, $nrorgTrab){
        try{
            $now = new TkDateTime();
            $now = $now->toString(TkDateTime::FORMAT_DATE);

            $this->setNrtipoferias($nrtipoferias);
            $this->setDtinivigencia($now);
            $this->setNrorg($nrorgTrab);
            $this->setDtinclusao($now);

            $this->persist();
            return true;
        }
        catch (Exception $e){
            return false;
        }

    }

    public function destroiMestre($nrtipoferias, $nrorgTrab){
        try{
            $tipoferias = Fpatipoferiasm::retornaTipoFeriasPelaChave($nrtipoferias, $nrorgTrab);
            if (is_object($tipoferias) === true) {
                $this->addItem($tipoferias, $nrtipoferias);
                $this->removeItem($tipoferias);
                $this->persist();

                return true;
            } else {
                return false;
            }
        }
        catch (Exception $e){
            return false;
        }

    }

    public static function retornaDiasDireito($nrTipoFerias, $nrOrgPadrao=null, $nrOrgTrabalho=null)
    {
        switch ($nrTipoFerias){
            case 1:
            case 2:
                $diasDireito=2.5;
                break;
            case 3:
                $diasDireito=1.5;
                break;
            case 4:
                $diasDireito=1.3333333333333;
                break;
            case 5:
                $diasDireito=1.1666666666667;
                break;
            case 6:
                $diasDireito=1;
                break;
            case 7:
                $diasDireito=0.8333333333333;
                break;
            case 8:
                $diasDireito=0.6666666666666;
                break;
            default:
                $diasDireito=2.5;
        }
        return $diasDireito;
    }
}

