<?php

namespace Vab\Controllers;

use Vab\Services\CalculoBeneficioService;
use Util\Environment;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Error, Message };
use Zeedhi\Framework\DTO\Response\Notification;


class CalculoBeneficioController {
    /** @var CalculoBeneficioService */
    protected $calculoBeneficioService;

    public function __construct(
        Environment $environment,
        CalculoBeneficioService $calculoBeneficioService
    ) {
        $this->environment                  = $environment;
        $this->calculoBeneficioService      = $calculoBeneficioService;
    }
    
    public function calcular(Request\Row $request, Response $response)
    {
        try {
            $row = $request->getRow();
            
            $result = $this->calculoBeneficioService->calcularBeneficio($row);
            $response->addDataSet(new DataSet('calcular', [$result]));
        } catch (\Exception $e) {
            $variables = null;
            /*if ($e instanceof CustomException) {
                $variables = $e->getVariables();
            }
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR, null, $variables));
            */
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR, null, $variables));
        }
    }
    
}