<?php

namespace Vab\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;
use Folha\Entities\VabBeneficiario;
use Folha\Util\Valor;

use Util\DateUtil;
use Util\{
    //FileUploader,
    //HCMParameters,
    Repositories,
    //Util
    NovoCodigo
};

class CalculoBeneficioRepository {
    /** @var EntityManager */
    protected $entityManager;

    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->entityManager        = $entityManager;
        $this->connection           = $entityManager->getConnection();
    }
    
    public static function getBeneficiarioPorVinculo2($nrorg, $nrvinculom, $dtmescompetenc, $tpperiodo, $nrtpbeneficio=null, $nrestruturam=null){
        try {
            $sql = "SELECT * FROM VAB_BENEFICIARIO WHERE NRVINCULOM = $nrvinculom AND
                NRORG = $nrorg AND
                NRBENEFICIOM IN (SELECT BM.NRBENEFICIOM
                                   FROM VAB_BENEFICIOM BM
                                   JOIN VAB_BENEFICIOH BH ON BH.NRORG = BM.NRORG
                                                         AND BH.NRBENEFICIOM = BM.NRBENEFICIOM
                                                         AND BH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                                                   WHERE NRORG = BH.NRORG
                                                                                     AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                                                     AND DTMESCOMPETENC <= '$dtmescompetenc')
                                  WHERE BM.NRORG = $nrorg
                                    AND BM.IDATIVO = 'S'
                                    AND BH.TPPERIODOBENEF = '$tpperiodo'
                    ";
                    
            $sql .= $nrtpbeneficio ? "AND BH.NRTPBENEFICIO = $nrtpbeneficio" : "";
            $sql .= $nrestruturam ? "AND BH.NRESTRUTURAM = $nrestruturam" : "";
            $sql .= ")";
            
            $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
            
            if(isset($result))return $result;
            else return null;
        }  catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteVabApuraBeneficio($nrcalculobenef, $nrvinculom, $nrEvento, $nrPessoaBeneficiario, $tipoEvento, $nrbeneficiom, $nrorg){
        try{
            $query = $this->entityManager->getConnection()->prepare("
                DELETE FROM VAB_APURABENEFICIO
                WHERE 
                    NRORG = :P_NRORG 
                    AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA 
                    AND NRVINCULOM = :P_NRVINCULOM 
                    AND NRPESSOA = :P_NRPESSOA
                    AND NREVENTOM = :P_NREVENTOM
                    AND DSTIPOBENEFICIO = :P_DSTIPOBENEFICIO
                    AND NRBENEFICIOM = :P_NRBENEFICIOM"
            );
            $query->execute(
                array(
                    "P_NRCALCULOFOLHA"   => $nrcalculobenef,
                    "P_NRVINCULOM"       => $nrvinculom,
                    "P_NREVENTOM"        => $nrEvento,
                    "P_DSTIPOBENEFICIO"  => $tipoEvento,
                    "P_NRORG"            => $nrorg,
                    "P_NRPESSOA"         => $nrPessoaBeneficiario,
                    "P_NRBENEFICIOM"     => $nrbeneficiom
                )
            );
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function persistirHistorico_Diario($nrorgTrab, $dtcompetencia, $cdoperador,$nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrEvento, $valorEvento, $arrayDiasCalculados, $dtIni, $dtFim, $dtpagamento, $vlrTotalBenef, $qtdeBeneficio, $idcalccomplementar = null, $valorAdescontar = null){
            
            $query = $this->entityManager->getConnection()->prepare("
                INSERT INTO VAB_HISTBENEFVINC 
                (
                    NRHISTBENEFVINC,
                    NRBENEFICIOM,
                    NRVINCULOM,
                    NRCALCULOFOLHA,
                    NREVENTOM,
                    NRORG,
                    DTMESCOMPETENC,
                    DTINIAPURBENEF,
                    DTFINAPURBENEF,
                    DTPGTOBENEF,
                    QTAPURBENEF,
                    QTDIASBENEF,
                    QTDIASAFASTA,
                    QTDIASFALTAS,
                    QTDIASFERIAS,
                    QTDIASAVISO,
                    QTDIASDSR,
                    VRBENEFICIO,
                    VRDEDUCAOBENEF,
                    VRTOTALBENEF,
                    IDATIVO,
                    NRORGINCLUSAO,
                    DTINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    DTULTATU,
                    CDOPERULTATU,
                    QTDIASFERIADO,
                    QTDIASTRABPERIODO,           
                    QTDIASATESTADO,
                    IDCALCCOMPLEMENTAR
                )

                VALUES (
                    :P_NRHISTBENEFVINC,
                    :P_NRBENEFICIOM,
                    :P_NRVINCULOM,
                    :P_NRCALCULOFOLHA,
                    :P_NREVENTOM,
                    :P_NRORG,
                    :P_DTMESCOMPETENC,
                    :P_DTINIAPURBENEF,
                    :P_DTFINAPURBENEF,
                    :P_DTPGTOBENEF,
                    :P_QTAPURBENEF,
                    :P_QTDIASBENEF,
                    :P_QTDIASAFASTA,
                    :P_QTDIASFALTAS,
                    :P_QTDIASFERIAS,
                    :P_QTDIASAVISO,
                    :P_QTDIASDSR,
                    :P_VRBENEFICIO,
                    :P_VRDEDUCAOBENEF,
                    :P_VRTOTALBENEF,
                    :P_IDATIVO,
                    :P_NRORGINCLUSAO,
                    :P_DTINCLUSAO,
                    :P_CDOPERINCLUSAO,
                    :P_NRORGULTATU,
                    :P_DTULTATU,
                    :P_CDOPERULTATU,
                    :P_QTDIASFERIADO,
                    :P_QTDIASTRABPERIODO,           
                    :P_QTDIASATESTADO,
                    :P_IDCALCCOMPLEMENTAR
                )"
            );

            $query->execute(
                array(
                    "P_NRHISTBENEFVINC"   => intval(NovoCodigo::geraCodigo($nrorgTrab, 'VAB_HISTBENEFVINC', 1, 22, true)),
                    "P_NRBENEFICIOM"      => intval($nrbeneficiom),
                    "P_NRVINCULOM"        => intval($nrvinculom),
                    "P_NRCALCULOFOLHA"    => intval($nrcalculobenef),
                    "P_NREVENTOM"         => intval($nrEvento),
                    "P_NRORG"             => $nrorgTrab,
                    
                    "P_DTMESCOMPETENC"    => $dtcompetencia,
                    "P_DTINIAPURBENEF"    => substr($dtIni, 0, 10),
                    "P_DTFINAPURBENEF"    => substr($dtFim, 0, 10),
                    "P_DTPGTOBENEF"       => substr($dtpagamento, 0, 10),
                    
                    "P_QTAPURBENEF"       => $qtdeBeneficio,
                    "P_QTDIASBENEF"       => intval($arrayDiasCalculados['DIASCONSIDERACAO']),
                    "P_QTDIASAFASTA"      => intval($arrayDiasCalculados['DIASAFASTAMENTO']),
                    "P_QTDIASFALTAS"      => intval($arrayDiasCalculados['DIASFALTAS']),
                    "P_QTDIASFERIAS"      => intval($arrayDiasCalculados['DIASFERIAS']),
                    "P_QTDIASAVISO"       => intval($arrayDiasCalculados['DIASAVISO']),
                    "P_QTDIASDSR"         => intval($arrayDiasCalculados['DIASDSR']),
                    "P_QTDIASATESTADO"    => intval($arrayDiasCalculados['DIASATESTADO']),
                    "P_VRBENEFICIO"       => $valorEvento,
                    "P_VRDEDUCAOBENEF"    => $valorAdescontar,
                    "P_VRTOTALBENEF"      => $vlrTotalBenef,
                    "P_IDATIVO"           => "S",
                    "P_NRORGINCLUSAO"     => intval($nrorgTrab),
                    "P_DTINCLUSAO"        => DateUtil::getDataAtual()->format('d/m/Y H:i:s'),
                    "P_CDOPERINCLUSAO"    => intval($cdoperador),
                    "P_NRORGULTATU"       => intval($nrorgTrab),
                    "P_DTULTATU"          => DateUtil::getDataAtual()->format('d/m/Y H:i:s'),
                    "P_CDOPERULTATU"      => intval($cdoperador),
                    "P_QTDIASFERIADO"     => intval($arrayDiasCalculados['DIASFERIADO']),
                    "P_QTDIASTRABPERIODO" => intval($arrayDiasCalculados['DIASDETRABALHONOPERIODO']),
                    "P_IDCALCCOMPLEMENTAR"=> $idcalccomplementar,
                )
            );

    }
    
    public function getTipoRelacionamentoPorPessoa($nrvinculom, $nrpessoa, $nrorg, $dtcompetencia){
        $query = <<<SQL
    SELECT 
        RP.NRTIPORELACIONA,
        PH.DTNASCPESSOA,
        PH.NMPESSOA,
        PH.IDSEXOPESSOA AS IDSEXOPESSOA
    FROM 
        GPE_VINCULOM VM
    JOIN 
        GPE_PESSOA P1
            ON(
                VM.NRPESSOA  = P1.NRPESSOA
                AND VM.NRORG = P1.NRORG
            )
    JOIN 
        RELACIONAPARC RP
            ON(
                P1.NRPARCNEGOCIO = RP.NRPARCNEGOCIO
                AND P1.NRORG     = RP.NRORG
            )
    JOIN
        GPE_PESSOA P2
            ON(
                P2.NRPESSOA          = :NRPESSOA
                AND P2.NRORG         = RP.NRORG
                AND P2.NRPARCNEGOCIO = RP.NRPARCNEGRELAC
            )
    LEFT JOIN 
        GPE_PESSOAH PH
            ON(
                PH.NRORG              = P2.NRORG
                AND PH.NRPESSOA       = P2.NRPESSOA
                AND PH.DTMESCOMPETENC = 
                                    (SELECT 
                                        MAX(PH2.DTMESCOMPETENC)
                                     FROM 
                                        GPE_PESSOAH PH2
                                     WHERE 
                                        PH2.NRORG              = PH.NRORG
                                        AND PH2.NRPESSOA       = PH.NRPESSOA
                                        AND PH2.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                    )
            )
    WHERE
        VM.NRORG = :NRORG AND VM.NRVINCULOM = :NRVINCULOM
SQL;

        $retorno = $this->connection->fetchAssoc($query,[ 
                                                    "NRPESSOA"       => $nrpessoa,
                                                    "NRORG"          => $nrorg,
                                                    "NRVINCULOM"     => $nrvinculom,
                                                    "DTMESCOMPETENC" => $dtcompetencia
                                                   ]
                                           );
        return $retorno;
    }
    
    public function getSalarioPorCompetencia($nrorg, $nrvinculom, $dtcompetencia)
    {
        try {
            $dtcompetencia = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($dtcompetencia, DateUtil::FORMATO_BRASILEIRO, true))->format('d/m/Y');
            $query = 
<<<SQL

SELECT *
FROM GPE_ALTESALARIO SAL
WHERE SAL.NRORG = :P_NRORG
 AND SAL.NRVINCULOM = :P_VINCULOM
 AND SAL.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO)
                           FROM GPE_ALTESALARIO SAL2
                           WHERE SAL2.NRORG = :P_NRORG
                            AND SAL2.NRVINCULOM = :P_VINCULOM
                            AND SAL2.DTALTESALARIO <= :P_DTCOMPETENCIA 
                        )
SQL;
            $params = array(
                'P_NRORG'       => $nrorg,
                'P_VINCULOM'    => $nrvinculom,
                'P_DTCOMPETENCIA' => $dtcompetencia,
            );
            
            $result = $this->connection->fetchAssoc($query, $params);
            
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function updateTotalVinculosProcessados($nrcalculoconsumer, $totalAdicionar, $nrorg){
        if(!empty($nrcalculoconsumer)){
            $query = $this->entityManager->getConnection()->prepare("
                UPDATE FPA_CALCULOCONSUMER
            SET NRTOTPROCESSVINC = (NRTOTPROCESSVINC + :P_TOTALADD)
            WHERE NRORG = :P_NRORG AND
                NRCALCULOCONSUMER = :P_NRCALCULOCONSUMER"
            );
            $query->execute(
                array(
                    "P_NRCALCULOCONSUMER" => $nrcalculoconsumer,
                    "P_NRORG"   => $nrorg,
                    "P_TOTALADD"=> $totalAdicionar
                )
            );
        }
    }
    
    public function persistirCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $nrEventoValorEvento, $tipoEvento, $nrorg, $competencia, $cdoperador){
        $row_fpaIteCalcFolha = null;
        
        $row_fpaIteCalcFolha = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findOneBy( 
            [ 
             'nrcalculofolha' => $nrcalculobenef,
             'nrvinculom'     => $nrvinculom,
             'nreventom'      => key($nrEventoValorEvento),
             'nrorg'          => $nrorg,
             'dtocorrencia'   => Dateutil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true),
            ]
        );

        if (
                ( !$row_fpaIteCalcFolha || !$row_fpaIteCalcFolha->getNrlotelancevento() ) &&
                count($nrEventoValorEvento) > 0 && ($nrEventoValorEvento[key($nrEventoValorEvento)] >= 0) 
            
           ) {
               
            $this->deleteVabApuraBeneficio($nrcalculobenef, $nrvinculom, key($nrEventoValorEvento), $nrPessoaBeneficiario, $tipoEvento, $nrbeneficiom, $nrorg);
            
            $vlrEvento = $nrEventoValorEvento[key($nrEventoValorEvento)];
            
            $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                key($nrEventoValorEvento),
                $nrorg, 
                0, 
                $competencia
            );                    
            
             $vlrEvento = Valor::arredonda(
                $vlrEvento,
                $eventoh->historico->getIdtipoarredonda(), 
                $eventoh->historico->getNrdigarredonda(),
                $eventoh->historico->getVrlimitearred()
            );
            
            $query = $this->entityManager->getConnection()->prepare("
                INSERT INTO VAB_APURABENEFICIO (          
                  NRAPURABENEFICIO,
                  NRCALCULOFOLHA,
                  NRVINCULOM,
                  NRPESSOA,
                  NRBENEFICIOM,
                  DSTIPOBENEFICIO,
                  NREVENTOM,
                  VRAPURABENEFICIO,
                  NRORG,
                  IDATIVO,
                  DTINCLUSAO,
                  DTULTATU,
                  NRORGINCLUSAO,
                  NRORGULTATU,
                  CDOPERINCLUSAO,
                  CDOPERULTATU              
                ) 
                
                VALUES (
                  :P_NRAPURABENEFICIO,
                  :P_NRCALCULOFOLHA,
                  :P_NRVINCULOM,
                  :P_NRPESSOA,
                  :P_NRBENEFICIOM,
                  :P_DSTIPOBENEFICIO,
                  :P_NREVENTOM,
                  :P_VRAPURABENEFICIO,
                  :P_NRORG,
                  :P_IDATIVO,
                  :P_DTINCLUSAO,
                  :P_DTULTATU,
                  :P_NRORGINCLUSAO,
                  :P_NRORGULTATU,
                  :P_CDOPERINCLUSAO,
                  :P_CDOPERULTATU              
                )"
            );
            $query->execute(
                array(
                    "P_NRAPURABENEFICIO" => NovoCodigo::geraCodigo($nrorg, 'VAB_APURABENEFICIO', 1, 22, true),
                    "P_NRCALCULOFOLHA"   => $nrcalculobenef,
                    "P_NRVINCULOM"       => $nrvinculom,
                    "P_NRPESSOA"         => $nrPessoaBeneficiario,
                    "P_NRBENEFICIOM"     => $nrbeneficiom,
                    "P_DSTIPOBENEFICIO"  => $tipoEvento,
                    "P_NREVENTOM"        => key($nrEventoValorEvento),
                    "P_VRAPURABENEFICIO" => $vlrEvento,
                    "P_NRORG"            => $nrorg,
                    "P_IDATIVO"          => "S",
                    "P_DTINCLUSAO"       => DateUtil::getDataAtual()->format('d/m/Y h:m:s'),
                    "P_DTULTATU"         => DateUtil::getDataAtual()->format('d/m/Y h:m:s'),
                    "P_NRORGINCLUSAO"    => $nrorg,
                    "P_NRORGULTATU"      => $nrorg,
                    "P_CDOPERINCLUSAO"   => $cdoperador,
                    "P_CDOPERULTATU"     => $cdoperador
                )
            );       
        }
    }
    
    public function getBeneficioPorVinculo($dtmescompetenc, $nrorg, $nrbeneficiom){
        $query = <<<SQL
    SELECT
        BNM.*,
        BNH.*
    FROM
        VAB_BENEFICIOM BNM 
    INNER JOIN
        VAB_BENEFICIOH BNH 
            ON BNH.NRBENEFICIOM = BNM.NRBENEFICIOM 
            AND(
                BNM.NRORG = BNH.NRORG 
            ) 
            AND BNH.DTMESCOMPETENC =(
                    SELECT
                        MAX(BNEH.DTMESCOMPETENC) 
                FROM
                    VAB_BENEFICIOH BNEH 
                WHERE
                    BNEH.NRORG = BNH.NRORG 
                    AND BNEH.NRBENEFICIOM = BNH.NRBENEFICIOM 
                    AND BNEH.DTMESCOMPETENC <= :DTMESCOMPETENC
            )        
    WHERE 
        BNM.NRBENEFICIOM = :NRBENEFICIOM
        AND BNM.NRORG = :NRORG
SQL;

        $retorno = $this->connection->fetchAll($query,[ 
                                                    "DTMESCOMPETENC" => $dtmescompetenc,
                                                    "NRORG"         => $nrorg,
                                                    "NRBENEFICIOM"  => $nrbeneficiom,
                                                   ]
                                           );
        return $retorno[0];
    }
    
    public function validaLiquidoBeneficioOcorrencia1($nrtipomoviment, $nrcalculofolha, $nrvinculom, $dtmescompetencia, $nrorg, $nreventom, $dtpagamento, $nrocorrencia){
        try {
        $query = <<<SQL
    SELECT
        ITEC.*,
        CF.NROCORRECAL,
        CF.NRTIPOMOVIMENT
    FROM
        FPA_ITECALCFOLHA ITEC
        JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITEC.NRCALCULOFOLHA
        AND CF.NRORG = ITEC.NRORG
        AND CF.NROCORRECAL = 1
        AND CF.NRTIPOMOVIMENT = :P_NRTPMOVIMENT
    WHERE
            ITEC.NRORG = :P_NRORG
        AND ITEC.NREVENTOM = :P_NREVENTOM
        AND ITEC.DTOCORRENCIA = :P_DTPAGAMENTO
        AND ITEC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
        AND ITEC.NRVINCULOM = :P_NRVINCULOM
SQL;

        $retorno = $this->connection->fetchAll($query,[ 
                                                    'P_NRORG'            => $nrorg,
                                                    'P_NRVINCULOM'       => $nrvinculom,
                                                    'P_NRCALCULOFOLHA'   => $nrcalculofolha,
                                                    'P_NREVENTOM'        => $nreventom,
                                                    'P_DTPAGAMENTO'      => $dtpagamento,
                                                    'P_NRTPMOVIMENT'     => $nrtipomoviment,
                                                   ]
                                           );
        return $retorno;
        } 
        catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function validaLiquidoBeneficio($nrcalculofolha, $nrvinculom, $dtmescompetencia, $nrorg, $nreventom, $dtpagamento){
        try {
        $query = <<<SQL
    SELECT * 
    FROM FPA_ITECALCFOLHA 
    WHERE 
        NRORG = :P_NRORG 
        AND  NREVENTOM = :P_NREVENTOM
        AND NRVINCULOM = :P_NRVINCULOM 
        AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA
        AND DTOCORRENCIA = :P_DTPAGAMENTO
SQL;

        $retorno = $this->connection->fetchAll($query,[ 
                                                    'P_NRORG'            => $nrorg,
                                                    'P_NRVINCULOM'       => $nrvinculom,
                                                    'P_NRCALCULOFOLHA'   => $nrcalculofolha,
                                                    'P_NREVENTOM'        => $nreventom,
                                                    'P_DTPAGAMENTO'      => $dtpagamento
                                                   ]
                                           );
        return $retorno;
        } 
        catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getBeneficioDescontoSind($dtmescompetenc, $nrorg, $nrTpBeneficio, $nrEstrutSind){
        try {
        $query = <<<SQL
    SELECT
        BCCT.*
    
    FROM 
        FPA_CADASTROCCT CCT 

    JOIN
        VAB_BENEFICIOCCT BCCT
            ON BCCT.NRCADASTROCCT = CCT.NRCADASTROCCT
            AND BCCT.NRORG = CCT.NRORG
    
    WHERE 
        BCCT.NRTPBENEFICIO = :NRTPBENEFICIO
        AND CCT.NRESTRUTURAM = :NRESTRUTURASIND
        AND CCT.NRORG = :NRORG
        AND CCT.IDATIVO = 'S'
        AND CCT.DTANOBASECCT = (SELECT MAX(DTANOBASECCT) FROM FPA_CADASTROCCT CCT2
                        WHERE CCT2.IDATIVO = 'S'
                        AND CCT2.NRORG = CCT.NRORG
                        AND CCT2.NRESTRUTURAM = CCT.NRESTRUTURAM
                        AND CCT2.DTANOBASECCT <= :DTMESCOMPETENC
                       )
SQL;
        $params = [ 
                    "DTMESCOMPETENC"  => $dtmescompetenc,
                    "NRORG"           => $nrorg,
                    "NRTPBENEFICIO"   => intval($nrTpBeneficio),
                    "NRESTRUTURASIND" => intval($nrEstrutSind),
                  ];
        
        $retorno = $this->connection->fetchAll($query, $params);
        
        if(is_array($retorno) && isset($retorno[0])) $retorno = $retorno[0];
        else $retorno = null;

        return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}
